VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "HashProvider"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'-------- VBGuard Begin --------
Private Const MODULENAME_ = "HashProvider"
'-------- VBGuard End ----------
Option Explicit
'CryptAcquireContext(
'HCRYPTPROV *phProv,    [out] The address to which the function copies a handle to the CSP.
'LPCTSTR pszContainer,  [in]  The key container name. This is a zero-terminated string that identifies the key container to the CSP
'                               vbNullChar used in this example to get the default key container.
'LPCTSTR pszProvider,   [in] The provider name. This is a zero-terminated string that specifies the CSP to be used
'DWORD dwProvType,      [in] The type of provider to acquire
'DWORD dwFlags          [in] The flag values
') As Long

Private Declare Function CryptAcquireContext Lib "advapi32.dll" Alias "CryptAcquireContextA" ( _
    phProv As Long, pszContainer As String, pszProvider As String, _
    ByVal dwProvType As Long, ByVal dwFlags As Long) As Long
    
'CryptReleaseContext(
'HCRYPTPROV hProv,  [in] A handle to the applications CSP
'DWORD dwFlags      [in] The flag values. This parameter is reserved for future use and should always be zero
');
Private Declare Function CryptReleaseContext Lib "advapi32.dll" _
    (ByVal hProv As Long, _
    ByVal dwFlags As Long) As Long

'CryptCreateHash(
'    HCRYPTPROV hProv,      [in] A handle to the CSP to use. An application obtains this handle using the CryptAcquireContext function.
'    ALG_ID Algid,          [in] An algorithm identifier of the hash algorithm to use
'    HCRYPTKEY hKey,        [in] For nonkeyed algorithms, this parameter should be set to zero
'    DWORD dwFlags,         [in] The flag values. This parameter is reserved for future use and should always be zero
'    HCRYPTHASH *phHash);   [out] The address to which the function copies a handle to the new hash object.
Private Declare Function CryptCreateHash Lib "advapi32.dll" (ByVal hProv As Long, _
    ByVal Algid As Long, ByVal hKey As Long, ByVal dwFlags As Long, phHash As Long) As Long

'CryptDestroyHash(
'    HCRYPTHASH hHash [in] A handle to the hash object to be destroyed
');
Private Declare Function CryptDestroyHash Lib "advapi32.dll" (ByVal hHash As Long) As Long

'CryptHashData(
'    HCRYPTHASH hHash,      [in] A handle to the hash object. An application obtains this handle using the CryptCreateHash function.
'    CONST BYTE *pbData,    [in] The address of the data to be hashed
'    DWORD dwDataLen,       [in] The number of bytes of data to be hashed.
'    DWORD dwFlags);        [in] The flag values (The Microsoft RSA Base Provider ignores this parameter)
Private Declare Function CryptHashData Lib "advapi32.dll" ( _
ByVal hHash As Long, ByVal pbdata As String, _
ByVal dwDataLen As Long, ByVal dwFlags As Long) As Long
    
'CryptGetHashParam(
'   HCRYPTHASH hHash,   [in] A handle to the hash object on which to query parameters
'   DWORD dwParam,      [in] The parameter number
'   BYTE *pbData,       [out] The parameter data buffer
'   DWORD *pdwDataLen,  [in/out] The address of the parameter data length.
'   DWORD dwFlags       [in] The flag values. This parameter is reserved for future use and should always be zero.
');
Private Declare Function CryptGetHashParam Lib "advapi32.dll" _
(ByVal hHash As Long, ByVal dwParam As Long, pbdata As Any, _
 pdwDataLen As Long, ByVal dwFlags As Long) As Long
 
Private Declare Function GetLastError Lib "kernel32" () As Long
' Name of the provider shipped with Windows by default
' Both support below declared hashing algorithms.
' MS_DEF_PROV is bundled with the operating system.
Private Const MS_DEF_PROV = "Microsoft Base Cryptographic Provider v1.0"
Private Const MS_ENHANCED_PROV = "Microsoft Enhanced Cryptographic Provider v1.0"
Private Const PROV_RSA_FULL = 1
Private Const CRYPT_NEWKEYSET = &H8
'// Hash sub ids
'#define ALG_SID_MD2                     1
Private Const ALG_SID_MD2 = 1
'#define ALG_SID_MD4
Private Const ALG_SID_MD4 = 2
'#define ALG_SID_MD5                     3
Private Const ALG_SID_MD5 = 3
'#define ALG_SID_SHA                     4
Private Const ALG_SID_SHA = 4

' // Hash classes
'#define ALG_CLASS_HASH                  (4 << 13)
Private Const ALG_CLASS_HASH = 32768

'// Algorithm types
'#define ALG_TYPE_ANY                    (0)
Private Const ALG_TYPE_ANY = 0

'// algorithm identifier definitions
'#define CALG_MD2                (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_MD2)
Private Const CALG_MD2 = (ALG_CLASS_HASH Or ALG_TYPE_ANY Or ALG_SID_MD2)
'#define CALG_MD4                (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_MD4)
Private Const CALG_MD4 = (ALG_CLASS_HASH Or ALG_TYPE_ANY Or ALG_SID_MD4)
'#define CALG_MD5        (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_MD5)
Private Const CALG_MD5 = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_MD5)
'#define CALG_SHA        (ALG_CLASS_HASH | ALG_TYPE_ANY | ALG_SID_SHA)
Private Const CALG_SHA = (ALG_CLASS_HASH Or ALG_TYPE_ANY Or ALG_SID_SHA)

'// CryptGetHashParam parameter number values
'#define HP_ALGID                0x0001  // Hash algorithm
Private Const HP_ALGID = 1
'#define HP_HASHVAL              0x0002  // Hash value
Private Const HP_HASHVAL = 2
'#define HP_HASHSIZE             0x0004  // Hash value size
Private Const HP_HASHSIZE = 4
'
' Block size to read from file to hash
Private Const HP_FILE_BLOCKSIZE = 160
' ERROR Constants
' For cryptHashData
Private Const ERROR_INVALID_HANDLE = 6&
Private Const ERROR_INVALID_PARAMETER = 87 '  dderror
Private Const ERROR_NTE_BAD_UID = &H80090001
Private Const ERROR_BAD_HASH = &H80090002
Private Const ERROR_BAD_LEN = &H80090004
Private Const ERROR_NTE_BAD_ALGID = &H80090008
Private Const ERROR_NTE_BAD_HASH_STATE = &H8009000C
Private Const ERROR_NTE_NO_MEMORY = &H8009000E
Private Const ERROR_NTE_FAIL = &H80090020

Public Enum HASH_ALG_ID
    HP_MD2
    HP_MD4
    HP_MD5
    HP_SHA
End Enum
Public Enum HASH_DATA_FORMAT
    HP_HEXADECIMAL
    HP_NUMERIC
    HP_ASCII
End Enum
Private Enum HASH_STATUS
    HP_STATUS_NONE
    HP_STATUS_READY
    HP_STATUS_BUSY
End Enum


' Private variables
Private m_Hash_Object As Long
Private m_Hash_Data(20) As Byte 'This value will usually be 16 or 20, depending on the hash algorithm.
Private m_Hash_DataLen As Long
Private m_Hash_Algo_Id As HASH_ALG_ID
Private m_Hash_Algorithm As Long
Private m_Hash_Status As HASH_STATUS
Private m_CSP_Provider As Long
Private m_Hash_DataReady As Boolean

Private Sub Class_Initialize()
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "Class_Initialize"
'-------- VBGuard End ----------
'    m_Hash_Status = HP_STATUS_NONE
'    m_Hash_Algo_Id = HP_MD5
'-------- VBGuard Begin --------
    Exit Sub
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Sub

Private Sub Class_Terminate()
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "Class_Terminate"
'-------- VBGuard End ----------
On Error Resume Next
101     If m_Hash_Object Then CryptDestroyHash m_Hash_Object
102     If m_CSP_Provider Then CryptReleaseContext m_CSP_Provider, 0
'-------- VBGuard Begin --------
    Exit Sub
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Sub

Public Property Get Algorithm() As EC_HASH_ALG_ID
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "Algorithm[Property Get]"
'-------- VBGuard End ----------
    Algorithm = m_Hash_Algo_Id
'-------- VBGuard Begin --------
    Exit Property
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Property
Public Property Let Algorithm(ByVal algNewValue As EC_HASH_ALG_ID)
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "Algorithm[Property Let]"
'-------- VBGuard End ----------
    m_Hash_Algo_Id = algNewValue
'-------- VBGuard Begin --------
    Exit Property
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Property
Public Property Get IsDataReady() As Boolean
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "IsDataReady[Property Get]"
'-------- VBGuard End ----------
    IsDataReady = m_Hash_DataReady
'-------- VBGuard Begin --------
    Exit Property
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Property
' Read only property
Public Property Get HashObject() As Long
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "HashObject[Property Get]"
'-------- VBGuard End ----------
    Select Case m_Hash_Status
        Case HP_STATUS_NONE:
102             Err.Raise vbObjectError + 1001, "Hash Provider", _
            "The Hash object has not been created yet."
        Case HP_STATUS_BUSY Or HP_STATUS_READY:
104             HashObject = m_Hash_Object
105     End Select
'-------- VBGuard Begin --------
    Exit Property
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Property

Public Function CreateByCSPRef(CSPProvider As Long) As Long
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "CreateByCSPRef"
'-------- VBGuard End ----------
    If m_Hash_Object Then CryptDestroyHash m_Hash_Object
    ' I am very optimistic
102     CreateByCSPRef = 1
103     Select Case m_Hash_Algo_Id
        Case HP_MD2: m_Hash_Algorithm = CALG_MD2
        Case HP_MD4: m_Hash_Algorithm = CALG_MD4
        Case HP_MD5: m_Hash_Algorithm = CALG_MD5
        Case HP_SHA: m_Hash_Algorithm = CALG_SHA
108     End Select
109     If m_Hash_Object Then CryptDestroyHash m_Hash_Object
110     If Not CBool(CryptCreateHash(CSPProvider, m_Hash_Algorithm, 0, 0, m_Hash_Object)) Then
111         m_Hash_Status = HP_STATUS_NONE
112         CreateByCSPRef = 0
113         Err.Raise vbObjectError + 1002, "Hash Provider", _
                  "An error has occurred creating hash object"
114     Else
115         m_Hash_Status = HP_STATUS_READY
116     End If
'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function

Public Function CreateHashObject() As Long
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "CreateHashObject"
'-------- VBGuard End ----------

101     If m_Hash_Object Then CryptDestroyHash m_Hash_Object
    
103     Dim sProvider As String
104     Dim sContainer As String
105     Select Case m_Hash_Algo_Id
        Case HP_MD2: m_Hash_Algorithm = CALG_MD2
        Case HP_MD4: m_Hash_Algorithm = CALG_MD4
        Case HP_MD5: m_Hash_Algorithm = CALG_MD5
        Case HP_SHA: m_Hash_Algorithm = CALG_SHA
110     End Select
    
112     sContainer = vbNullChar
113     sProvider = MS_ENHANCED_PROV & vbNullChar
    ' I am very optimistic
115     CreateHashObject = 1
116     If m_CSP_Provider = 0 Then
         'Attempt to acquire a handle to the default key container.
118         If Not CBool(CryptAcquireContext(m_CSP_Provider, ByVal sContainer, ByVal sProvider, PROV_RSA_FULL, 0)) Then
            ' Attempt to get a handle to the enhanced key container
120             sProvider = MS_DEF_PROV & vbNullChar
121             If Not CBool(CryptAcquireContext(m_CSP_Provider, ByVal sContainer, ByVal sProvider, PROV_RSA_FULL, 0)) Then
                'If it is not possible to get a handle to none of those
                '[default] OP containers, raise an error as
                'the creation of key containers is out of the working
                'scope of this object.
126                 CreateHashObject = 0
127                 Err.Raise vbObject + 1003, "Hash Provider", "Error getting a handle to key containers"
128             End If
129         End If
130     End If
    'Attempt to acquire a handle to a Hash object
132     If Not CBool(CryptCreateHash(m_CSP_Provider, m_Hash_Algorithm, _
            0, 0, m_Hash_Object)) Then
133             CreateHashObject = 0
134             Err.Raise vbObject + 1002, "Hash Provider", "An error has occurred creating hash object"
135     End If
136     m_Hash_Status = HP_STATUS_READY
'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function

Public Function GetHashObject() As Long
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "GetHashObject"
'-------- VBGuard End ----------
''    If m_Hash_Status = HP_STATUS_READY Or m_Hash_Status = HP_STATUS_BUSY Then
101         GetHashObject = m_Hash_Object
''    Else
''        GetHashObject = 0
''    End If
'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function
Public Function DigestDataFile(ByVal sFilePath As String) As Long
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "DigestDataFile"
'-------- VBGuard End ----------
On Error GoTo ErrHandler
101 m_Hash_Status = HP_STATUS_BUSY
102 Dim fNum As Long, fLen As Long, fBlockBytes As Long, fLostBytes As Long
103 Dim fdat() As Byte, fsDat As String
104 Dim iCounter As Integer, jCounter As Integer
105 Dim lResult As Long
106 fNum = FreeFile()
' Optimistic
108 DigestDataFile = 1
' First we check if the file exists
110 If Trim(Dir(sFilePath)) = "" Then
111     Err.Raise vbObjectError + 1007, "Hash Provider", "File not found"
112 End If
113 Open sFilePath For Binary Access Read As #fNum
114     fLen = LOF(fNum)
115     If fLen < HP_FILE_BLOCKSIZE Then
        ' Resize dynamic array
117         ReDim fdat(fLen)
        ' Get the data
119         Get #fNum, , fdat()
        ' Convert to string one by one
121         For iCounter = 0 To fLen - 1
122             fsDat = fsDat & Chr(fdat(iCounter))
123         Next
        ' And finally digest the data
        'lResult = DigestDataBlock(fsDat)
126         If Not CBool(CryptHashData(m_Hash_Object, fsDat, fLen, 0)) Then
127            DigestDataFile = 0
128            Err.Raise vbObjectError + 1005, "Hash Provider", _
                "An error occurred digesting the data."
129                 m_Hash_Status = HP_STATUS_READY '[?]
130         End If
131     Else
        ' Find out how many blocks the file holds
133         fBlockBytes = fLen / HP_FILE_BLOCKSIZE
        ' Find out how many bytes are lost
135         fLostBytes = fLen Mod HP_FILE_BLOCKSIZE
        ' Now loop the number of blocks
        ' [First resize array]
138         ReDim fdat(HP_FILE_BLOCKSIZE)
139         For iCounter = 1 To fBlockBytes
            ' Now get the data
141             Get #fNum, , fdat()
            ' Convert to string one by one
143             For jCounter = 0 To HP_FILE_BLOCKSIZE
144                 fsDat = fsDat & Chr(fdat(jCounter))
145             Next
            ' Digest the data
            'lResult = DigestDataBlock(fsDat)
148             If Not CBool(CryptHashData(m_Hash_Object, fsDat, HP_FILE_BLOCKSIZE, 0)) Then
149                DigestDataFile = 0
150                Err.Raise vbObjectError + 1005, "Hash Provider", _
                    "An error occurred digesting the data."
151                     m_Hash_Status = HP_STATUS_READY '[?]
152             End If
            ' Now clear the buffer string to do it again
154             fsDat = ""
155         Next
156         If fLostBytes <> 0 Then
            ' Process lost bytes [bytes remaining]
158             ReDim fdat(fLostBytes)
            ' Get the remaining data
160             Get #fNum, , fdat()
            ' Convert to string one by one
162             For jCounter = 0 To fLostBytes - 1
163                 fsDat = fsDat & Chr(fdat(jCounter))
164             Next
            ' Digest the data [BURP!-- sorry ;~)]
            'lResult = DigestDataBlock(fsDat)
167             If Not CBool(CryptHashData(m_Hash_Object, fsDat, fLostBytes, 0)) Then
168                DigestDataFile = 0
169                Err.Raise vbObjectError + 1005, "Hash Provider", _
                    "An error occurred digesting the data."
170                     m_Hash_Status = HP_STATUS_READY '[?]
171             End If
172         End If
173     End If
174 Close #fNum
175 Call SetHashData
176 m_Hash_Status = HP_STATUS_READY
177 Exit Function
178 ErrHandler:
    ' Raise error
180     Err.Raise Err.Number, "Hash Provider", Err.Description
'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function
Public Function DigestDataBlock(ByVal sData As String) As Long
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "DigestDataBlock"
'-------- VBGuard End ----------
Dim lDataLen As Long
101     If m_Hash_Status = HP_STATUS_NONE Then
102         Err.Raise vbObjectError + 1001, "Hash Provider", _
            "The Hash object has not been created yet."
103     End If
104     m_Hash_Status = HP_STATUS_BUSY
    ' I am very optimistic
106     DigestDataBlock = 1
107     lDataLen = Len(sData)
108     If Not CBool(CryptHashData(m_Hash_Object, sData, lDataLen, 0)) Then
        'ERROR_INVALID_HANDLE   ' One of the parameters specifies an invalid handle.
        'ERROR_INVALID_PARAMETER    ' One of the parameters contains an invalid value. This is most often an illegal pointer.
        'NTE_BAD_ALGID   ' The hHash handle specifies an algorithm that this CSP does not support.
        'NTE_BAD_FLAGS       ' The dwFlags parameter contains an invalid value.
        'NTE_BAD_HASH        ' The hash object specified by the hHash parameter is invalid.
        'NTE_BAD_HASH_STATE  ' An attempt was made to add data to a hash object that is already marked finished.
        'NTE_BAD_KEY     ' A keyed hash algorithm is being used, but the session key is no longer valid. This error will be generated if the session key is destroyed before the hashing operating is complete.
        'NTE_BAD_LEN     ' The CRYPT_USERDATA flag is set and the dwDataLen parameter has a nonzero value.
        'NTE_BAD_UID     ' The CSP context that was specified when the hash object was created cannot be found.
        'NTE_FAIL        ' The function failed in some unexpected way.
        'NTE_NO_MEMORY   ' The CSP ran out of memory during the operation
120         DigestDataBlock = 0
121         Err.Raise vbObjectError + 1005, "Hash Provider", _
            "An error occurred processing the data."
122         m_Hash_Status = HP_STATUS_READY '[?]
123     End If
124     Call SetHashData
125     m_Hash_Status = HP_STATUS_READY
'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function

Public Function GetHashData(Optional ByVal hpDataFormat As HASH_DATA_FORMAT = HP_HEXADECIMAL) As String
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "GetHashData"
'-------- VBGuard End ----------
Dim sData As String, sHex As String
101 Dim iCounter As Integer
102 If m_Hash_Status = HP_STATUS_NONE Then
103     Err.Raise vbObjectError + 1001, "Hash Provider", _
            "The Hash object has not been created yet."
104 End If
105 If m_Hash_DataLen = 0 Then
106     GetHashData = "Nothing has been digested yet!"
107 End If
108 m_Hash_Status = HP_STATUS_BUSY
109     Select Case hpDataFormat
    Case HP_HEXADECIMAL
111         For iCounter = 0 To m_Hash_DataLen - 1
112             sHex = Hex(m_Hash_Data(iCounter))
113             If Len(sHex) > 1 Then
114                 sData = sData & sHex & vbTab
115             Else
116                 sData = sData & "0" & sHex & vbTab
117             End If
118             sHex = ""
119         Next
    Case HP_NUMERIC
121         For iCounter = 0 To m_Hash_DataLen - 1
122             sData = sData & CStr(m_Hash_Data(iCounter))
123         Next
    Case HP_ASCII
        'Open "C:\Hash.txt" For Binary As #1
126         For iCounter = 0 To m_Hash_DataLen - 1
        
128             sData = sData & Chr(m_Hash_Data(iCounter))
129         Next
        'Put #1, , sData
       'Close #1
132     End Select
133     GetHashData = sData
134     m_Hash_Status = HP_STATUS_READY
'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function
Private Sub SetHashData()
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "SetHashData"
'-------- VBGuard End ----------
    m_Hash_DataReady = False
101     If m_Hash_Status = HP_STATUS_NONE Then Exit Sub ' For now
        ' Make a first call to find out the size needed for the buffer
'    Call CryptGetHashParam(m_Hash_Object, HP_HASHSIZE, bDataLen(0), lDataLen, 0)
    'If lDataLen = 0 Then
    '    Err.Raise vbObjectError + 1006, "Hash Provider", "An error has occurred when getting hash value."
        ' Raise Error?
   ' Else
108    m_Hash_DataLen = 20&
109    If Not CBool(CryptGetHashParam(m_Hash_Object, HP_HASHVAL, m_Hash_Data(0), _
                  m_Hash_DataLen, 0)) Then
                  'API error function
111             m_Hash_DataLen = 0
            ' Raise Error?
    '       ERROR_INVALID_HANDLE One of the parameters specifies an invalid handle.
    '       ERROR_INVALID_PARAMETER One of the parameters contains an invalid value. This is most often an illegal pointer.
    '       NTE_BAD_FLAGS The dwFlags parameter is nonzero.
    '       NTE_BAD_HASH The hash object specified by the hHash parameter is invalid.
    '       NTE_BAD_TYPE The dwParam parameter specifies an unknown parameter number.
    '       NTE_BAD_UID The CSP context that was specified when the hash was created cannot be found.
119             Err.Raise vbObjectError + 1006, "Hash Provider", "An error has occurred when getting hash value."
120    End If
121    m_Hash_DataReady = True
'-------- VBGuard Begin --------
    Exit Sub
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Sub
