Attribute VB_Name = "Registry"
'-------- VBGuard Begin --------
Private Const MODULENAME_ = "Registry"
'-------- VBGuard End ----------
Option Explicit
'/--------------------------------------------------\
'| I've added extra registry functions for your use |
'| Feel free to change the function titles          |
'\--------------------------------------------------/

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_DYN_DATA = &H80000006
Public Const REG_SZ = 1                         ' Unicode nul terminated string
Public Const REG_BINARY = 3                     ' Free form binary
Public Const REG_DWORD = 4                      ' 32-bit number
Public Const ERROR_SUCCESS = 0&

Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Public Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
'--------------------------------------------------
Public Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Public Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long
'--------------------------------------------------
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Public Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long

Public Sub CreateKey(hKey As Long, strPath As String)
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "CreateKey"
'-------- VBGuard End ----------
Dim hCurKey As Long
101 Dim lRegResult As Long

103 lRegResult = RegCreateKey(hKey, strPath, hCurKey)

105 If lRegResult <> ERROR_SUCCESS Then
  ' there is a problem
107 End If

109 lRegResult = RegCloseKey(hCurKey)

'-------- VBGuard Begin --------
    Exit Sub
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Sub

Public Sub DeleteKey(ByVal hKey As Long, ByVal strPath As String)
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "DeleteKey"
'-------- VBGuard End ----------
Dim lRegResult As Long

102 lRegResult = RegDeleteKey(hKey, strPath)

'-------- VBGuard Begin --------
    Exit Sub
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Sub

Public Sub DeleteValue(ByVal hKey As Long, ByVal strPath As String, ByVal strValue As String)
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "DeleteValue"
'-------- VBGuard End ----------
Dim hCurKey As Long
101 Dim lRegResult As Long

103 lRegResult = RegOpenKey(hKey, strPath, hCurKey)

105 lRegResult = RegDeleteValue(hCurKey, strValue)

107 lRegResult = RegCloseKey(hCurKey)

'-------- VBGuard Begin --------
    Exit Sub
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Sub

Public Function GetSettingString(hKey As Long, strPath As String, strValue As String, Optional Default As String) As String
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "GetSettingString"
'-------- VBGuard End ----------
Dim hCurKey As Long
101 Dim lValueType As Long
102 Dim strBuffer As String
103 Dim lDataBufferSize As Long
104 Dim intZeroPos As Integer
105 Dim lRegResult As Long

' Set up default value
108 If Not IsEmpty(Default) Then
109   GetSettingString = Default
110 Else
111   GetSettingString = ""
112 End If

' Open the key and get length of string
115 lRegResult = RegOpenKey(hKey, strPath, hCurKey)
116 lRegResult = RegQueryValueEx(hCurKey, strValue, 0&, lValueType, ByVal 0&, lDataBufferSize)

118 If lRegResult = ERROR_SUCCESS Then

120   If lValueType = REG_BINARY Then
    ' initialise string buffer and retrieve string
122     strBuffer = String(lDataBufferSize, " ")
123     lRegResult = RegQueryValueEx(hCurKey, strValue, 0&, 0&, ByVal strBuffer, lDataBufferSize)
    
    ' format string
126     intZeroPos = InStr(strBuffer, Chr$(0))
127     If intZeroPos > 0 Then
128       GetSettingString = Left$(strBuffer, intZeroPos - 1)
129     Else
130       GetSettingString = strBuffer
131     End If

133   End If

135 Else
  ' there is a problem
137 End If

139 lRegResult = RegCloseKey(hCurKey)
'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function

Public Sub SaveSettingString(hKey As Long, strPath As String, strValue As String, strData As String)
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "SaveSettingString"
'-------- VBGuard End ----------
Dim hCurKey As Long
101 Dim lRegResult As Long

103 lRegResult = RegCreateKey(hKey, strPath, hCurKey)

105 lRegResult = RegSetValueEx(hCurKey, strValue, 0, REG_BINARY, ByVal strData, Len(strData))

107 If lRegResult <> ERROR_SUCCESS Then
  'there is a problem
109 End If

111 lRegResult = RegCloseKey(hCurKey)
'-------- VBGuard Begin --------
    Exit Sub
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Sub

Public Function GetSettingLong(ByVal hKey As Long, ByVal strPath As String, ByVal strValue As String, Optional Default As Long) As Long
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "GetSettingLong"
'-------- VBGuard End ----------

101 Dim lRegResult As Long
102 Dim lValueType As Long
103 Dim lBuffer As Long
104 Dim lDataBufferSize As Long
105 Dim hCurKey As Long

' Set up default value
108 If Not IsEmpty(Default) Then
109   GetSettingLong = Default
110 Else
111   GetSettingLong = 0
112 End If

114 lRegResult = RegOpenKey(hKey, strPath, hCurKey)
115 lDataBufferSize = 4       ' 4 bytes = 32 bits = long

117 lRegResult = RegQueryValueEx(hCurKey, strValue, 0&, lValueType, lBuffer, lDataBufferSize)

119 If lRegResult = ERROR_SUCCESS Then

121   If lValueType = REG_DWORD Then
122     GetSettingLong = lBuffer
123   End If

125 Else
  'there is a problem
127 End If

129 lRegResult = RegCloseKey(hCurKey)

'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function

Public Sub SaveSettingLong(ByVal hKey As Long, ByVal strPath As String, ByVal strValue As String, ByVal lData As Long)
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "SaveSettingLong"
'-------- VBGuard End ----------
Dim hCurKey As Long
101 Dim lRegResult As Long

103 lRegResult = RegCreateKey(hKey, strPath, hCurKey)

105 lRegResult = RegSetValueEx(hCurKey, strValue, 0&, REG_DWORD, lData, 4)

107 If lRegResult <> ERROR_SUCCESS Then
  'there is a problem
109 End If

111 lRegResult = RegCloseKey(hCurKey)
'-------- VBGuard Begin --------
    Exit Sub
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Sub

Public Function GetSettingByte(ByVal hKey As Long, ByVal strPath As String, ByVal strValueName As String, Optional Default As Variant) As Variant
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "GetSettingByte"
'-------- VBGuard End ----------
Dim lValueType As Long
101 Dim byBuffer() As Byte
102 Dim lDataBufferSize As Long
103 Dim lRegResult As Long
104 Dim hCurKey As Long

' setup default value
107 If Not IsEmpty(Default) Then
108   If VarType(Default) = vbArray + vbByte Then
109     GetSettingByte = Default
110   Else
111     GetSettingByte = 0
112   End If

114 Else
115   GetSettingByte = 0
116 End If

' Open the key and get number of bytes
119 lRegResult = RegOpenKey(hKey, strPath, hCurKey)
120 lRegResult = RegQueryValueEx(hCurKey, strValueName, 0&, lValueType, ByVal 0&, lDataBufferSize)

122 If lRegResult = ERROR_SUCCESS Then

124   If lValueType = REG_BINARY Then
  
    ' initialise buffers and retrieve value
127     ReDim byBuffer(lDataBufferSize - 1) As Byte
128     lRegResult = RegQueryValueEx(hCurKey, strValueName, 0&, lValueType, byBuffer(0), lDataBufferSize)
    
130     GetSettingByte = byBuffer

132   End If

134 Else
  'there is a problem
136 End If

138 lRegResult = RegCloseKey(hCurKey)

'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function

Public Sub SaveSettingByte(ByVal hKey As Long, ByVal strPath As String, ByVal strValueName As String, byData() As Byte)
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "SaveSettingByte"
'-------- VBGuard End ----------
' Make sure that the array starts with element 0 before passing it!
' (otherwise it will not be saved!)

103 Dim lRegResult As Long
104 Dim hCurKey As Long

106 lRegResult = RegCreateKey(hKey, strPath, hCurKey)

' Pass the first array element and length of array
109 lRegResult = RegSetValueEx(hCurKey, strValueName, 0&, REG_BINARY, byData(0), UBound(byData()) + 1)

111 lRegResult = RegCloseKey(hCurKey)

'-------- VBGuard Begin --------
    Exit Sub
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Sub

Public Function GetAllKeys(hKey As Long, strPath As String) As Variant
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "GetAllKeys"
'-------- VBGuard End ----------
' Returns: an array in a variant of strings

102 Dim lRegResult As Long
103 Dim lCounter As Long
104 Dim hCurKey As Long
105 Dim strBuffer As String
106 Dim lDataBufferSize As Long
107 Dim strNames() As String
108 Dim intZeroPos As Integer

110 lCounter = 0

112 lRegResult = RegOpenKey(hKey, strPath, hCurKey)

114 Do

  'initialise buffers (longest possible length=255)
117   lDataBufferSize = 255
118   strBuffer = String(lDataBufferSize, " ")
119   lRegResult = RegEnumKey(hCurKey, lCounter, strBuffer, lDataBufferSize)

121   If lRegResult = ERROR_SUCCESS Then
  
    'tidy up string and save it
124     ReDim Preserve strNames(lCounter) As String
    
126     intZeroPos = InStr(strBuffer, Chr$(0))
127     If intZeroPos > 0 Then
128       strNames(UBound(strNames)) = Left$(strBuffer, intZeroPos - 1)
129     Else
130       strNames(UBound(strNames)) = strBuffer
131     End If

133     lCounter = lCounter + 1

135   Else
136     Exit Do
137   End If
138 Loop

140 GetAllKeys = strNames
'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function

Public Function GetAllValues(hKey As Long, strPath As String) As Variant
'-------- VBGuard Begin --------
        On Error GoTo VBGuardLocalHandler
        Const PROCNAME_ = "GetAllValues"
'-------- VBGuard End ----------
' Returns: a 2D array.
' (x,0) is value name
' (x,1) is value type (see constants)

104 Dim lRegResult As Long
105 Dim hCurKey As Long
106 Dim lValueNameSize As Long
107 Dim strValueName As String
108 Dim lCounter As Long
109 Dim byDataBuffer(4000) As Byte
110 Dim lDataBufferSize As Long
111 Dim lValueType As Long
112 Dim strNames() As String
113 Dim lTypes() As Long
114 Dim intZeroPos As Integer

116 lRegResult = RegOpenKey(hKey, strPath, hCurKey)

118 Do
  ' Initialise bufffers
120   lValueNameSize = 255
121   strValueName = String$(lValueNameSize, " ")
122   lDataBufferSize = 4000
  
124   lRegResult = RegEnumValue(hCurKey, lCounter, strValueName, lValueNameSize, 0&, lValueType, byDataBuffer(0), lDataBufferSize)
  
126   If lRegResult = ERROR_SUCCESS Then
    
    ' Save the type
129     ReDim Preserve strNames(lCounter) As String
130     ReDim Preserve lTypes(lCounter) As Long
131     lTypes(UBound(lTypes)) = lValueType
    
    'Tidy up string and save it
134     intZeroPos = InStr(strValueName, Chr$(0))
135     If intZeroPos > 0 Then
136       strNames(UBound(strNames)) = Left$(strValueName, intZeroPos - 1)
137     Else
138       strNames(UBound(strNames)) = strValueName
139     End If

141     lCounter = lCounter + 1

143   Else
144     Exit Do
145   End If
146 Loop

'Move data into array
149 Dim Finisheddata() As Variant
150 ReDim Finisheddata(UBound(strNames), 0 To 1) As Variant

152 For lCounter = 0 To UBound(strNames)
153   Finisheddata(lCounter, 0) = strNames(lCounter)
154   Finisheddata(lCounter, 1) = lTypes(lCounter)
155 Next

157 GetAllValues = Finisheddata

'-------- VBGuard Begin --------
    Exit Function
VBGuardLocalHandler:
    Select Case VBGuardGlobalHandler(MODULENAME_, PROCNAME_)
    Case vbAbort
        Err.Raise Err.Number
    Case vbRetry
        Resume
    Case vbIgnore
        Resume Next
    End Select
'-------- VBGuard End ----------
End Function

